/******************************************************************************/
/**									     **/
/**		      Copyright 1990 by Computer Science Dept.  	     **/
/**			University College London, England		     **/
/**									     **/
/**									     **/
/**									     **/
/** Permission to use, copy and modify (but NOT distribute) this software    **/
/** and its documentation for any purpose and without fee is hereby granted, **/
/** provided the above copyright notice appears in all copies, and that both **/
/** that copyright notice and this permission notice appear in supporting    **/
/** documentation, and that the name Pygmalion not be used in advertising or **/
/** publicity of the software without specific, written prior permission of  **/
/** Thomson-CSF.							     **/
/**									     **/
/** THE DEPARTMENT OF COMPUTER SCIENCE, UNIVERSITY COLLEGE LONDON DISCLAIMS  **/
/** ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED       **/
/** WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE 	     **/
/** DEPARTMENT OF COMPUTER SCIENCE, UNIVERSITY COLLEGE LONDON BE LIABLE FOR  **/
/** ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER **/
/** RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF     **/
/** CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN      **/
/** CONJUNCTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.		     **/
/**									     **/
/******************************************************************************/

/******************************************************************************
 * Pygmalion Programming Environment v 1.02 3/3/90
 *
 * pgm 
 *
 * showconf.c
 ******************************************************************************/

#include <stdio.h>
#include "everything.h"

/* display the configuration */

void show_rpconf(sysp, filename)
rpcsys *sysp;
char	filename[];
{
  int n, l, c, s;
  FILE *flp;

  tmpnam(filename);
  flp = fopen(filename, "w");
  fprintf(flp, "config = { nets = %d;\n", sysp->rpcsys_len);
  for (n=0; n<sysp->rpcsys_len; n++) {
     fprintf(flp, "\t\t{ layers = %d;\n", sysp->rpcsys_val[n].rpcnet_len);
     for (l=0; l<sysp->rpcsys_val[n].rpcnet_len; l++) {
	fprintf(flp, "\t\t\t{ clusters = %d;\n",
			sysp->rpcsys_val[n].rpcnet_val[l].rpclay_len);
	for (c=0; c<sysp->rpcsys_val[n].rpcnet_val[l].rpclay_len; c++) {
	   fprintf(flp, "\t\t\t\t{ neurons = %d; },\n",
		sysp->rpcsys_val[n].rpcnet_val[l].rpclay_val[c].rpcclu_len);
/*	   for (s=0;
	   	s<sysp->rpcsys_val[n].rpcnet_val[l].rpclay_val[c].rpcclu_len;
	   	s++)
	      fprintf(flp, "%d  ",
     sysp->rpcsys_val[n].rpcnet_val[l].rpclay_val[c].rpcclu_val[s].fanin);
*/
	}
	fprintf(flp, "\n\t\t\t},\n");
     }
     fprintf(flp, "\t\t},\n");
  }
  fprintf(flp, "\t},\n");
  fclose(flp);
}

