
typedef char fname[200];
bool_t xdr_fname();


struct magali_fname {
	char rule_name[40];
	int rule_pointer;
};
typedef struct magali_fname magali_fname;
bool_t xdr_magali_fname();


struct magali_iarray {
	char name[40];
	float value;
};
typedef struct magali_iarray magali_iarray;
bool_t xdr_magali_iarray();


struct patfile {
	char name[200];
	int index;
};
typedef struct patfile patfile;
bool_t xdr_patfile();


struct patres {
	int width[2];
	int height[2];
};
typedef struct patres patres;
bool_t xdr_patres();


typedef struct {
	u_int farray_len;
	float *farray_val;
} farray;
bool_t xdr_farray();


typedef struct {
	u_int iarray_len;
	magali_iarray *iarray_val;
} iarray;
bool_t xdr_iarray();


typedef struct {
	u_int fnarray_len;
	magali_fname *fnarray_val;
} fnarray;
bool_t xdr_fnarray();


typedef struct {
	u_int bitweight_len;
	u_int *bitweight_val;
} bitweight;
bool_t xdr_bitweight();


typedef struct {
	u_int wvaluetype_len;
	float *wvaluetype_val;
} wvaluetype;
bool_t xdr_wvaluetype();


struct rec {
	int errorn;
	union {
		farray sttwgt;
		fnarray names;
		iarray dontkno;
		bitweight bitconnect;
		wvaluetype wvalue;
	} rec_u;
};
typedef struct rec rec;
bool_t xdr_rec();


struct strctname {
	int indx[6];
	int namecode;
};
typedef struct strctname strctname;
bool_t xdr_strctname();


struct twoindx {
	int fromindx[4];
	int toindx[4];
};
typedef struct twoindx twoindx;
bool_t xdr_twoindx();


struct roadsize {
	int fromroad[4];
	int toroad[4];
	int size;
};
typedef struct roadsize roadsize;
bool_t xdr_roadsize();


struct rpcneu {
	int fanin;
};
typedef struct rpcneu rpcneu;
bool_t xdr_rpcneu();


typedef struct {
	u_int rpcclu_len;
	rpcneu *rpcclu_val;
} rpcclu;
bool_t xdr_rpcclu();


typedef struct {
	u_int rpclay_len;
	rpcclu *rpclay_val;
} rpclay;
bool_t xdr_rpclay();


typedef struct {
	u_int rpcnet_len;
	rpclay *rpcnet_val;
} rpcnet;
bool_t xdr_rpcnet();


typedef struct {
	u_int rpcsys_len;
	rpcnet *rpcsys_val;
} rpcsys;
bool_t xdr_rpcsys();


typedef rpcsys *rpcsyslist;
bool_t xdr_rpcsyslist();


struct confres {
	int errorn;
	union {
		rpcsyslist sys;
	} confres_u;
};
typedef struct confres confres;
bool_t xdr_confres();


typedef struct patnode *patlist;
bool_t xdr_patlist();


struct patnode {
	patlist next_ptr;
	char *filename;
	float score;
};
typedef struct patnode patnode;
bool_t xdr_patnode();


#define CMDLIBPROG ((u_long)99)
#define CMDLIBVERS ((u_long)1)
#define RINIT ((u_long)1)
extern int *rinit_1();
#define RSAVE ((u_long)2)
extern int *rsave_1();
#define RLOAD ((u_long)3)
extern int *rload_1();
#define RSYSCONF ((u_long)4)
extern confres *rsysconf_1();
#define RNETSTAT ((u_long)5)
extern rec *rnetstat_1();
#define REXECUTE ((u_long)6)
extern int *rexecute_1();
#define RREADINP ((u_long)7)
extern patres *rreadinp_1();
#define RREADALL ((u_long)13)
extern patres *rreadall_1();
#define RRANDWEIGHT ((u_long)8)
extern int *rrandweight_1();
#define RGETANYWEIGHT ((u_long)9)
extern rec *rgetanyweight_1();
#define RGETBITWEIGHT ((u_long)10)
extern rec *rgetbitweight_1();
#define RGETSPARSE ((u_long)11)
extern rec *rgetsparse_1();
#define RTERMINATESERV ((u_long)12)
extern int *rterminateserv_1();

